com.lowagie.text.rtf.list

## Class RtfListLevel

- java.lang.Object
- - com.lowagie.text.rtf.RtfElement
  - - com.lowagie.text.rtf.list.RtfListLevel

All Implemented Interfaces:
  RtfBasicElement, RtfExtendedElement, RtfElementInterface

    public class RtfListLevel
    extends RtfElement
    implements RtfExtendedElement

The RtfListLevel is a listlevel object in a list.

Since:
  2.1.3
Version:
  $Id$
Author:
  Howard Shank (hgshank@yahoo.com)

### Field Summary

Fields
`private int` `alignment` The alignment of this RtfList
`private java.lang.String` `bulletCharacter` The text to use as the bullet character
`private Chunk` `bulletChunk`
`private int` `firstIndent` The first indentation of this RtfList
`private RtfFont` `fontBullet` The RtfFont for bulleted lists
`private RtfFont` `fontNumber` The RtfFont for numbered lists
`private boolean` `isLegal` Flag to indicate if the levellegal control word should be emitted.
`private boolean` `isTentative` Flag to indicate if the tentative control word should be emitted.
`private int` `leftIndent` The left indentation of this RtfList
`private int` `levelFollowValue`
`private int` `levelPicture` Which picture bullet from the \listpicture destination should be applied
`private int` `levelTextNumber`
`private static byte[]` `LIST_LEVEL` Constant for list level
`private static byte[]` `LIST_LEVEL_ALIGNMENT` Constant for list level alignment old
`private static byte[]` `LIST_LEVEL_ALIGNMENT_NEW` Constant for list level alignment new
`private static byte[]` `LIST_LEVEL_FIRST_INDENT` Constant for the first indentation
`static int` `LIST_LEVEL_FOLLOW_NOTHING`
`static int` `LIST_LEVEL_FOLLOW_SPACE`
`static int` `LIST_LEVEL_FOLLOW_TAB`
`private static byte[]` `LIST_LEVEL_FOLOW` Constant which specifies which character follows the level text
`private static byte[]` `LIST_LEVEL_INDENT` Constant which specifies the levelindent control word
`private static byte[]` `LIST_LEVEL_LEGAL` Constant which specifies (1) if list numbers from previous levels should be converted to Arabic numbers; (0) if they should be left with the format specified by their own level's definition.
`private static byte[]` `LIST_LEVEL_NO_RESTART` Constant which specifies (1) if this level does/does not restart its count each time a super ordinate level is incremented (0) if this level does not restart its count each time a super ordinate level is incremented.
`private static byte[]` `LIST_LEVEL_NUMBERS_BEGIN` Constant for the beginning of the list level numbers
`private static byte[]` `LIST_LEVEL_NUMBERS_END` Constant for the end of the list level numbers
`private static byte[]` `LIST_LEVEL_NUMBERS_NUMBERED` Constant for the list level numbers
`private static byte[]` `LIST_LEVEL_PICTURE` Constant for the levelpictureN control word
`private static byte[]` `LIST_LEVEL_SPACE` Constant which specifies the levelspace controlword
`private static byte[]` `LIST_LEVEL_START_AT` Constant for list level start at
`private static byte[]` `LIST_LEVEL_STYLE_BULLETED_BEGIN` Constant for the beginning of the list level bulleted style
`private static byte[]` `LIST_LEVEL_STYLE_BULLETED_END` Constant for the end of the list level bulleted style
`private static byte[]` `LIST_LEVEL_STYLE_NUMBERED_BEGIN` Constant for the beginning of the list level numbered style
`private static byte[]` `LIST_LEVEL_STYLE_NUMBERED_END` Constant for the end of the list level numbered style
`private static byte[]` `LIST_LEVEL_SYMBOL_INDENT` Constant for the symbol indentation
`private static byte[]` `LIST_LEVEL_TEMPLATE_ID` Constant for list level
`private static byte[]` `LIST_LEVEL_TENTATIVE` Constant for the lvltentative control word
`private static byte[]` `LIST_LEVEL_TEXT` Constant for list level text
`private static byte[]` `LIST_LEVEL_TYPE` Constant for list level style old
`private static byte[]` `LIST_LEVEL_TYPE_NEW` Constant for list level style new
`static int` `LIST_TYPE_ARABIC`
`static int` `LIST_TYPE_ARABIC_LEADING_ZERO`
`static int` `LIST_TYPE_BASE`
`static int` `LIST_TYPE_BULLET`
`static int` `LIST_TYPE_CARDINAL_TEXT_NUMBER`
`static int` `LIST_TYPE_LOWER_LETTERS`
`static int` `LIST_TYPE_LOWER_ROMAN`
`static int` `LIST_TYPE_LOWERCASE_LETTER`
`static int` `LIST_TYPE_LOWERCASE_ROMAN_NUMERAL`
`static int` `LIST_TYPE_NO_NUMBER`
`static int` `LIST_TYPE_NUMBERED`
`static int` `LIST_TYPE_ORDINAL_NUMBER`
`static int` `LIST_TYPE_ORDINAL_TEXT_NUMBER`
`static int` `LIST_TYPE_UNKNOWN`
`static int` `LIST_TYPE_UPPER_LETTERS`
`static int` `LIST_TYPE_UPPER_ROMAN`
`static int` `LIST_TYPE_UPPERCASE_LETTER`
`static int` `LIST_TYPE_UPPERCASE_ROMAN_NUMERAL`
`private int` `listLevel` The level of this RtfListLevel
`private RtfListLevel` `listLevelParent`
`private int` `listNoRestart` Does the list restart numbering each time a super ordinate level is incremented
`private int` `listStartAt` The number to start counting at
`private int` `listType` Whether this RtfList is numbered
`private RtfList` `parent` Parent list object
`private int` `rightIndent` The right indentation of this RtfList
`private int` `symbolIndent` The symbol indentation of this RtfList
`private int` `templateID`

### Fields inherited from class com.lowagie.text.rtf.RtfElement

`document, inHeader, inTable`

### Fields inherited from interface com.lowagie.text.rtf.RtfBasicElement

`CLOSE_GROUP, COMMA_DELIMITER, DELIMITER, OPEN_GROUP, TWIPS_FACTOR`

### Constructor Summary

Constructors
Constructor and Description
`RtfListLevel(RtfDocument doc)`
`RtfListLevel(RtfDocument doc, RtfList parent)`
`RtfListLevel(RtfListLevel ll)`

### Method Summary

Methods
`protected void` `correctIndentation()` Correct the indentation of this level
`int` `getAlignment()`
`java.lang.String` `getBulletCharacter()`
`int` `getFirstIndent()`
`RtfFont` `getFontBullet()`
`RtfFont` `getFontNumber()`
`int` `getLeftIndent()`
`int` `getLevelFollowValue()`
`int` `getLevelTextNumber()`
`int` `getListLevel()` Gets the list level of this RtfList
`RtfListLevel` `getListLevelParent()`
`int` `getListNoRestart()`
`int` `getListStartAt()`
`int` `getListType()`
`RtfList` `getParent()`
`int` `getRightIndent()`
`int` `getSymbolIndent()`
`boolean` `isLegal()`
`boolean` `isTentative()`
`void` `setAlignment(int alignment)`
`void` `setBulletCharacter(java.lang.String bulletCharacter)`
`void` `setBulletChunk(Chunk bulletCharacter)`
`void` `setBulletFont(Font f)` set the bullet font
`void` `setFirstIndent(int firstIndent)`
`void` `setFontBullet(RtfFont fontBullet)`
`void` `setFontNumber(RtfFont fontNumber)`
`void` `setLeftIndent(int leftIndent)`
`void` `setLegal(boolean isLegal)`
`void` `setLevelFollowValue(int levelFollowValue)`
`void` `setLevelTextNumber(int levelTextNumber)`
`void` `setListLevel(int listLevel)` Sets the list level of this RtfList.
`void` `setListLevelParent(RtfListLevel listLevelParent)`
`void` `setListNoRestart(int listNoRestart)`
`void` `setListStartAt(int listStartAt)`
`void` `setListType(int listType)`
`void` `setParent(RtfList parent)`
`void` `setRightIndent(int rightIndent)`
`void` `setSymbolIndent(int symbolIndent)`
`void` `setTentative(boolean isTentative)`
`void` `writeContent(java.io.OutputStream result)` unused
`void` `writeDefinition(java.io.OutputStream result)` Write the definition part of the element
`void` `writeIndentation(java.io.OutputStream result)` Write the indentation values for this `RtfList`.
`void` `writeListBeginning(java.io.OutputStream result)` Writes the initialization part of the RtfList
`protected void` `writeListNumbers(java.io.OutputStream result)` Writes only the list number and list level number.

### Methods inherited from class com.lowagie.text.rtf.RtfElement

`intToByteArray, isInTable, setInHeader, setInTable, setRtfDocument`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.lowagie.text.rtf.RtfBasicElement

`setInHeader, setInTable, setRtfDocument`

### Field Detail

#### LIST_LEVEL

    private static final byte[] LIST_LEVEL

Constant for list level

#### LIST_LEVEL_TEMPLATE_ID

    private static final byte[] LIST_LEVEL_TEMPLATE_ID

Constant for list level

#### LIST_LEVEL_TYPE

    private static final byte[] LIST_LEVEL_TYPE

Constant for list level style old

#### LIST_LEVEL_TYPE_NEW

    private static final byte[] LIST_LEVEL_TYPE_NEW

Constant for list level style new

#### LIST_LEVEL_ALIGNMENT

    private static final byte[] LIST_LEVEL_ALIGNMENT

Constant for list level alignment old

#### LIST_LEVEL_ALIGNMENT_NEW

    private static final byte[] LIST_LEVEL_ALIGNMENT_NEW

Constant for list level alignment new

#### LIST_LEVEL_START_AT

    private static final byte[] LIST_LEVEL_START_AT

Constant for list level start at

#### LIST_LEVEL_TEXT

    private static final byte[] LIST_LEVEL_TEXT

Constant for list level text

#### LIST_LEVEL_STYLE_NUMBERED_BEGIN

    private static final byte[] LIST_LEVEL_STYLE_NUMBERED_BEGIN

Constant for the beginning of the list level numbered style

#### LIST_LEVEL_STYLE_NUMBERED_END

    private static final byte[] LIST_LEVEL_STYLE_NUMBERED_END

Constant for the end of the list level numbered style

#### LIST_LEVEL_STYLE_BULLETED_BEGIN

    private static final byte[] LIST_LEVEL_STYLE_BULLETED_BEGIN

Constant for the beginning of the list level bulleted style

#### LIST_LEVEL_STYLE_BULLETED_END

    private static final byte[] LIST_LEVEL_STYLE_BULLETED_END

Constant for the end of the list level bulleted style

#### LIST_LEVEL_NUMBERS_BEGIN

    private static final byte[] LIST_LEVEL_NUMBERS_BEGIN

Constant for the beginning of the list level numbers

#### LIST_LEVEL_FOLOW

    private static final byte[] LIST_LEVEL_FOLOW

Constant which specifies which character follows the level text

#### LIST_LEVEL_SPACE

    private static final byte[] LIST_LEVEL_SPACE

Constant which specifies the levelspace controlword

#### LIST_LEVEL_INDENT

    private static final byte[] LIST_LEVEL_INDENT

Constant which specifies the levelindent control word

#### LIST_LEVEL_LEGAL

    private static final byte[] LIST_LEVEL_LEGAL

Constant which specifies (1) if list numbers from previous levels should be converted to Arabic numbers; (0) if they should be left with the format specified by their own level's definition.

#### LIST_LEVEL_NO_RESTART

    private static final byte[] LIST_LEVEL_NO_RESTART

Constant which specifies (1) if this level does/does not restart its count each time a super ordinate level is incremented (0) if this level does not restart its count each time a super ordinate level is incremented.

#### LIST_LEVEL_NUMBERS_NUMBERED

    private static final byte[] LIST_LEVEL_NUMBERS_NUMBERED

Constant for the list level numbers

#### LIST_LEVEL_NUMBERS_END

    private static final byte[] LIST_LEVEL_NUMBERS_END

Constant for the end of the list level numbers

#### LIST_LEVEL_FIRST_INDENT

    private static final byte[] LIST_LEVEL_FIRST_INDENT

Constant for the first indentation

#### LIST_LEVEL_SYMBOL_INDENT

    private static final byte[] LIST_LEVEL_SYMBOL_INDENT

Constant for the symbol indentation

#### LIST_LEVEL_TENTATIVE

    private static final byte[] LIST_LEVEL_TENTATIVE

Constant for the lvltentative control word

#### LIST_LEVEL_PICTURE

    private static final byte[] LIST_LEVEL_PICTURE

Constant for the levelpictureN control word

#### LIST_TYPE_NUMBERED

    public static final int LIST_TYPE_NUMBERED

See Also:
  Constant Field Values

#### LIST_TYPE_UPPER_LETTERS

    public static final int LIST_TYPE_UPPER_LETTERS

See Also:
  Constant Field Values

#### LIST_TYPE_LOWER_LETTERS

    public static final int LIST_TYPE_LOWER_LETTERS

See Also:
  Constant Field Values

#### LIST_TYPE_UPPER_ROMAN

    public static final int LIST_TYPE_UPPER_ROMAN

See Also:
  Constant Field Values

#### LIST_TYPE_LOWER_ROMAN

    public static final int LIST_TYPE_LOWER_ROMAN

See Also:
  Constant Field Values

#### LIST_TYPE_UNKNOWN

    public static final int LIST_TYPE_UNKNOWN

See Also:
  Constant Field Values

#### LIST_TYPE_BASE

    public static final int LIST_TYPE_BASE

See Also:
  Constant Field Values

#### LIST_TYPE_ARABIC

    public static final int LIST_TYPE_ARABIC

See Also:
  Constant Field Values

#### LIST_TYPE_UPPERCASE_ROMAN_NUMERAL

    public static final int LIST_TYPE_UPPERCASE_ROMAN_NUMERAL

See Also:
  Constant Field Values

#### LIST_TYPE_LOWERCASE_ROMAN_NUMERAL

    public static final int LIST_TYPE_LOWERCASE_ROMAN_NUMERAL

See Also:
  Constant Field Values

#### LIST_TYPE_UPPERCASE_LETTER

    public static final int LIST_TYPE_UPPERCASE_LETTER

See Also:
  Constant Field Values

#### LIST_TYPE_LOWERCASE_LETTER

    public static final int LIST_TYPE_LOWERCASE_LETTER

See Also:
  Constant Field Values

#### LIST_TYPE_ORDINAL_NUMBER

    public static final int LIST_TYPE_ORDINAL_NUMBER

See Also:
  Constant Field Values

#### LIST_TYPE_CARDINAL_TEXT_NUMBER

    public static final int LIST_TYPE_CARDINAL_TEXT_NUMBER

See Also:
  Constant Field Values

#### LIST_TYPE_ORDINAL_TEXT_NUMBER

    public static final int LIST_TYPE_ORDINAL_TEXT_NUMBER

See Also:
  Constant Field Values

#### LIST_TYPE_ARABIC_LEADING_ZERO

    public static final int LIST_TYPE_ARABIC_LEADING_ZERO

See Also:
  Constant Field Values

#### LIST_TYPE_BULLET

    public static final int LIST_TYPE_BULLET

See Also:
  Constant Field Values

#### LIST_TYPE_NO_NUMBER

    public static final int LIST_TYPE_NO_NUMBER

See Also:
  Constant Field Values

#### listType

    private int listType

Whether this RtfList is numbered

#### bulletCharacter

    private java.lang.String bulletCharacter

The text to use as the bullet character

#### bulletChunk

    private Chunk bulletChunk

Since:
  2.1.4

#### listStartAt

    private int listStartAt

The number to start counting at

#### listLevel

    private int listLevel

The level of this RtfListLevel

#### firstIndent

    private int firstIndent

The first indentation of this RtfList

#### leftIndent

    private int leftIndent

The left indentation of this RtfList

#### rightIndent

    private int rightIndent

The right indentation of this RtfList

#### symbolIndent

    private int symbolIndent

The symbol indentation of this RtfList

#### isTentative

    private boolean isTentative

Flag to indicate if the tentative control word should be emitted.

#### isLegal

    private boolean isLegal

Flag to indicate if the levellegal control word should be emitted. true if any list numbers from previous levels should be converted to Arabic numbers; false if they should be left with the format specified by their own level definition.

#### listNoRestart

    private int listNoRestart

Does the list restart numbering each time a super ordinate level is incremented

#### LIST_LEVEL_FOLLOW_TAB

    public static final int LIST_LEVEL_FOLLOW_TAB

See Also:
  Constant Field Values

#### LIST_LEVEL_FOLLOW_SPACE

    public static final int LIST_LEVEL_FOLLOW_SPACE

See Also:
  Constant Field Values

#### LIST_LEVEL_FOLLOW_NOTHING

    public static final int LIST_LEVEL_FOLLOW_NOTHING

See Also:
  Constant Field Values

#### levelFollowValue

    private int levelFollowValue

#### alignment

    private int alignment

The alignment of this RtfList

#### levelPicture

    private int levelPicture

Which picture bullet from the \listpicture destination should be applied

#### levelTextNumber

    private int levelTextNumber

#### fontNumber

    private RtfFont fontNumber

The RtfFont for numbered lists

#### fontBullet

    private RtfFont fontBullet

The RtfFont for bulleted lists

#### templateID

    private int templateID

#### listLevelParent

    private RtfListLevel listLevelParent

#### parent

    private RtfList parent

Parent list object

### Constructor Detail

#### RtfListLevel

    public RtfListLevel(RtfDocument doc)

#### RtfListLevel

    public RtfListLevel(RtfDocument doc,
                RtfList parent)

#### RtfListLevel

    public RtfListLevel(RtfListLevel ll)

### Method Detail

#### getListNoRestart

    public int getListNoRestart()

Returns:
  the listNoRestart

#### setListNoRestart

    public void setListNoRestart(int listNoRestart)

Parameters:
  `listNoRestart` - the listNoRestart to set

#### getAlignment

    public int getAlignment()

Returns:
  the alignment

#### setAlignment

    public void setAlignment(int alignment)

Parameters:
  `alignment` - the alignment to set

#### writeDefinition

    public void writeDefinition(java.io.OutputStream result)
                         throws java.io.IOException

Description copied from interface: `RtfExtendedElement`
Write the definition part of the element

Specified by:
  `writeDefinition` in interface `RtfExtendedElement`
Parameters:
  `result` - The `OutputStream` to write the element definition to
Throws:
  `java.io.IOException`

#### writeContent

    public void writeContent(java.io.OutputStream result)
                      throws java.io.IOException

unused

Specified by:
  `writeContent` in interface `RtfBasicElement`
Specified by:
  `writeContent` in class `RtfElement`
Parameters:
  `result` - The `OutputStream` to write the content to
Throws:
  `java.io.IOException`

#### writeListNumbers

    protected void writeListNumbers(java.io.OutputStream result)
                             throws java.io.IOException

Writes only the list number and list level number.

Parameters:
  `result` - The `OutputStream` to write to
Throws:
  `java.io.IOException` - On i/o errors.

#### writeIndentation

    public void writeIndentation(java.io.OutputStream result)
                          throws java.io.IOException

Write the indentation values for this `RtfList`.

Parameters:
  `result` - The `OutputStream` to write to.
Throws:
  `java.io.IOException` - On i/o errors.

#### writeListBeginning

    public void writeListBeginning(java.io.OutputStream result)
                            throws java.io.IOException

Writes the initialization part of the RtfList

Parameters:
  `result` - The `OutputStream` to write to
Throws:
  `java.io.IOException` - On i/o errors.

#### correctIndentation

    protected void correctIndentation()

Correct the indentation of this level

#### getListLevel

    public int getListLevel()

Gets the list level of this RtfList

Returns:
  Returns the list level.

#### setListLevel

    public void setListLevel(int listLevel)

Sets the list level of this RtfList.

Parameters:
  `listLevel` - The list level to set.

#### getBulletCharacter

    public java.lang.String getBulletCharacter()

#### getListStartAt

    public int getListStartAt()

Returns:
  the listStartAt

#### setListStartAt

    public void setListStartAt(int listStartAt)

Parameters:
  `listStartAt` - the listStartAt to set

#### getFirstIndent

    public int getFirstIndent()

Returns:
  the firstIndent

#### setFirstIndent

    public void setFirstIndent(int firstIndent)

Parameters:
  `firstIndent` - the firstIndent to set

#### getLeftIndent

    public int getLeftIndent()

Returns:
  the leftIndent

#### setLeftIndent

    public void setLeftIndent(int leftIndent)

Parameters:
  `leftIndent` - the leftIndent to set

#### getRightIndent

    public int getRightIndent()

Returns:
  the rightIndent

#### setRightIndent

    public void setRightIndent(int rightIndent)

Parameters:
  `rightIndent` - the rightIndent to set

#### getSymbolIndent

    public int getSymbolIndent()

Returns:
  the symbolIndent

#### setSymbolIndent

    public void setSymbolIndent(int symbolIndent)

Parameters:
  `symbolIndent` - the symbolIndent to set

#### getParent

    public RtfList getParent()

Returns:
  the parent

#### setParent

    public void setParent(RtfList parent)

Parameters:
  `parent` - the parent to set

#### setBulletCharacter

    public void setBulletCharacter(java.lang.String bulletCharacter)

Parameters:
  `bulletCharacter` - the bulletCharacter to set

#### setBulletChunk

    public void setBulletChunk(Chunk bulletCharacter)

Parameters:
  `bulletCharacter` -
Since:
  2.1.4

#### getListType

    public int getListType()

Returns:
  the listType

#### setListType

    public void setListType(int listType)

Parameters:
  `listType` - the listType to set

#### setBulletFont

    public void setBulletFont(Font f)

set the bullet font

Parameters:
  `f` -

#### getFontNumber

    public RtfFont getFontNumber()

Returns:
  the fontNumber

#### setFontNumber

    public void setFontNumber(RtfFont fontNumber)

Parameters:
  `fontNumber` - the fontNumber to set

#### getFontBullet

    public RtfFont getFontBullet()

Returns:
  the fontBullet

#### setFontBullet

    public void setFontBullet(RtfFont fontBullet)

Parameters:
  `fontBullet` - the fontBullet to set

#### isTentative

    public boolean isTentative()

Returns:
  the isTentative

#### setTentative

    public void setTentative(boolean isTentative)

Parameters:
  `isTentative` - the isTentative to set

#### isLegal

    public boolean isLegal()

Returns:
  the isLegal

#### setLegal

    public void setLegal(boolean isLegal)

Parameters:
  `isLegal` - the isLegal to set

#### getLevelFollowValue

    public int getLevelFollowValue()

Returns:
  the levelFollowValue

#### setLevelFollowValue

    public void setLevelFollowValue(int levelFollowValue)

Parameters:
  `levelFollowValue` - the levelFollowValue to set

#### getLevelTextNumber

    public int getLevelTextNumber()

Returns:
  the levelTextNumber

#### setLevelTextNumber

    public void setLevelTextNumber(int levelTextNumber)

Parameters:
  `levelTextNumber` - the levelTextNumber to set

#### getListLevelParent

    public RtfListLevel getListLevelParent()

Returns:
  the listLevelParent

#### setListLevelParent

    public void setListLevelParent(RtfListLevel listLevelParent)

Parameters:
  `listLevelParent` - the listLevelParent to set